;**********************************************************************************
;**********************************************************************************
;*************  LIBRAIRIE KEY  ****************************************************
;gestion du clavier
;**********************************************************************************
;**********************************************************************************


;desactive toute les interruptions
clear_interrupts MACRO
 MOVE.w  #$700,D0                        ; Dsactive toutes les
 TRAP    #1                              ; interruptions masquables
 ENDM


;reactive toute les interruptions
restore_interrupts MACRO
 MOVE.w  #0,D0                           ; Active toutes les interruptions masquables
 TRAP    #1                              ; en dsarmant les bits 8, 9 et 10 de SR
 ENDM

;********* Scanne le clavier ***********;
get_key MACRO
 lea     keystat,a0
 move.w  #$FFFE,d0
 moveq   #6,d1
GetKeys:
 move.w  d0,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 move.b  $60001B,(a0)+
 rol.w	 #1,d0
 dbra    d1,GetKeys

 ENDM

;******************************************************************************************
;************   Teste une touche aprs l'appel de get_key    ******************************
;******************************************************************************************
;*** Voici une liste exhautive des touches testables :
test_on MACRO
 BTST.b  #1,$60001A
 ENDM

test_esc MACRO
 btst.b #0,keystat+6
 ENDM

test_2nd MACRO
 btst.b #4,keystat
 ENDM

test_diamond MACRO
 btst.b #6,keystat
 ENDM

test_left MACRO
 btst.b #1,keystat
 ENDM

test_right MACRO
 btst.b #3,keystat
 ENDM

test_clear MACRO
 btst.b #6,keystat+1
 ENDM

test_f1 MACRO
 btst.b #7,keystat+5
 ENDM

test_f2 MACRO
 btst.b #7,keystat+4
 ENDM

test_f3 MACRO
 btst.b #7,keystat+3
 ENDM

test_f4 MACRO
 btst.b #7,keystat+2
 ENDM

test_f5 MACRO
 btst.b #7,keystat+1
 ENDM

test_down MACRO
 btst.b #2,keystat
 ENDM

test_up MACRO
 btst.b #0,keystat
 ENDM

test_plus MACRO
 btst.b #1,keystat+1
 ENDM

test_moins MACRO
 btst.b #2,keystat+1
 ENDM

test_mul MACRO
 btst.b #3,keystat+1
 ENDM

test_div MACRO
 btst.b #4,keystat+1
 ENDM

keystat  ds.b 7
         dc.b 0           ; + 1 octet pour des adresse paires !
